package com.example.doubledeckerbus;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.*;
import javafx.scene.layout.AnchorPane;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.HashMap;
import java.util.Objects;
import java.util.Optional;


public class ControllerMapWithSetBus {
    static MapWithSetBusesGeneric<DrawingObjectBus, AbstractMap> _mapBusesCollectionGeneric;
    private final HashMap<String, AbstractMap> _mapsDict = new HashMap<>();
    {
        _mapsDict.put("Простая карта", new SimpleMap());
        _mapsDict.put("Водная карта", new WaterMap());
    }
    AbstractMap map = new SimpleMap();

    public static int AddNewBus (DrawingObjectBus bus) {
        return _mapsCollection.GetId(selected).add(bus);
    }
    static public MapsCollection _mapsCollection;

    static String selected;

    static String map_name = "Простая карта";
    protected ObservableList<String> countOfMap = FXCollections.observableArrayList("Простая карта", "Водная карта");

    @FXML
    private Canvas canvasBus;

    @FXML
    private ChoiceBox<String> comboBoxSelectorMap;

    @FXML
    private AnchorPane pictureBoxBus;

    @FXML
    private TextField textBoxPosition;

    @FXML
    private ListView<String> listViewMaps;

    @FXML
    private TextField TextFieldMap;

    @FXML
    private void initialize(){
        gc = canvasBus.getGraphicsContext2D();
        if (selected != null) {
            showStorage();
        }
        if (_mapsCollection == null)
            _mapsCollection = new MapsCollection((int) canvasBus.getWidth(), (int) canvasBus.getHeight());
        comboBoxSelectorMap.setItems(countOfMap);
        comboBoxSelectorMap.setValue(map_name);
        listViewMaps.getSelectionModel().selectedItemProperty()
                .addListener((observableValue, s, t1) -> {
                    selected = t1;
                    showStorage();
                });
        listViewMaps.setItems(_mapsCollection.toObserveList());
    }

    GraphicsContext gc;
    private void FirstIncome() {
        if (!Objects.equals(comboBoxSelectorMap.getValue(), map_name)) {
            map_name = comboBoxSelectorMap.getValue();
            switch (map_name) {
                case "Простая карта" -> map = new SimpleMap();
                case "Водная карта" -> map = new WaterMap();
            }
        }
    }

    private void ReloadMaps()
    {
        int index = listViewMaps.getSelectionModel().getSelectedIndex();

        ObservableList<String> listMaps = FXCollections.observableArrayList();

        listMaps.addAll(_mapsCollection.Keys());
        listViewMaps.setItems(listMaps);

        if (listMaps.size() > 0 && (index == -1 || index >= listMaps.size()))
        {
            listViewMaps.getSelectionModel().select(0);
        }
        else if (listMaps.size() > 0 && index > -1)
        {
            listViewMaps.getSelectionModel().select(index);
        }
    }

    @FXML
    private void ButtonAddBus_Click(ActionEvent event) throws IOException {
        if (listViewMaps.getSelectionModel().selectedItemProperty().isNull().get())
        {
            return;
        }
        Stage stageArmoredVehicleConfig = new Stage();
        FXMLLoader fxmlLoader = new FXMLLoader(Form.class.getResource("FormBusConfig.fxml"));
        Scene sceneArmoredVehicle = new Scene(fxmlLoader.load());

        stageArmoredVehicleConfig.setScene(sceneArmoredVehicle);
        stageArmoredVehicleConfig.show();

        ControllerBusConfig controllerArmoredVehicleConfig = fxmlLoader.getController();
        controllerArmoredVehicleConfig.AddEvent(this::AddBus);
        controllerArmoredVehicleConfig.SetStage(stageArmoredVehicleConfig);

        FirstIncome();
    }

    private void AddBus(DrawingBus bus) {
        if (listViewMaps.getSelectionModel().selectedItemProperty().isNull().get())
        {
            return;
        }
        DrawingObjectBus objectArmoredVehicle = new DrawingObjectBus(bus);
        String selectedMapName = listViewMaps.getSelectionModel().getSelectedItem();

        Alert alert;
        if (selectedMapName != null && selectedMapName.length() != 0 && _mapsCollection.get(selectedMapName).add(objectArmoredVehicle) != -1)
        {
            alert = new Alert(Alert.AlertType.INFORMATION, "Объект добавлен", ButtonType.OK);
            _mapsCollection.get(selectedMapName).ShowSet(gc);
        }
        else
        {
            alert = new Alert(Alert.AlertType.ERROR, "Не удалось добавить объект", ButtonType.OK);
        }
        alert.showAndWait();
    }

    @FXML
    private void ButtonAddMap_Click(ActionEvent event)
    {
        if ((Objects.equals(TextFieldMap.getText(), "")))
        {
            Alert alert = new Alert(Alert.AlertType.INFORMATION);
            alert.setTitle("SelectMap");
            alert.setContentText("Не все данные заполнены");
            Optional<ButtonType> option = alert.showAndWait();
            return;
        }
        if (!_mapsDict.containsKey(comboBoxSelectorMap.getValue()))
        {
            Alert alert = new Alert(Alert.AlertType.INFORMATION);
            alert.setTitle("SelectMap");
            alert.setContentText("Нет такой карты");
            Optional<ButtonType> option = alert.showAndWait();
            return;
        }
        _mapsCollection.AddMap(TextFieldMap.getText(), _mapsDict.get(comboBoxSelectorMap.getValue()));
        ReloadMaps();
        showStorage();
    }
    @FXML
    private void ButtonDeleteMap_Click(ActionEvent event)
    {
        if (listViewMaps.getSelectionModel().selectedItemProperty().isNull().get())
        {
            return;
        }
        _mapsCollection.DelMap(listViewMaps.getSelectionModel().getSelectedItem());
        ReloadMaps();
        showStorage();
    }

    @FXML
    private void ButtonDeleteEditBus_Click(ActionEvent event) throws IOException {
        if (selected == null)
        {
            return;
        }
        DrawingObjectBus deleteBus = _mapsCollection.get(selected).getDeletedBus();
        if (deleteBus != null) {
            ControllerBus._bus = deleteBus.getBus();
            FXMLLoader fxmlLoader = new FXMLLoader(Form.class.getResource("FormBus.fxml"));
            Scene scene = new Scene(fxmlLoader.load());
            Form.myStage.setTitle("DoubleDeckerBus");
            Form.myStage.setScene(scene);
            Form.myStage.show();
        }
    }

    @FXML
    private void ButtonRemoveBus_Click(ActionEvent event)
    {
        FirstIncome();
        if (Objects.equals(textBoxPosition.getText(), ""))
        {
            return;
        }
        Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
        alert.setTitle("RemoveBus");
        alert.setHeaderText("Вы действительно хотите удалить объект?");

        Optional<ButtonType> option = alert.showAndWait();
        if (option.get() == ButtonType.CANCEL) {
            return;
        }

        int pos;
        try {
            pos = Integer.parseInt(textBoxPosition.getText());
            if (pos < 1 || pos > _mapsCollection.GetId(selected).getCount()) return;
        }
        catch (Exception e) {
            return;
        }

        if (_mapsCollection.GetId(selected).remove(pos) != null)
        {
            alert = new Alert(Alert.AlertType.WARNING);
            alert.setTitle("RemoveBus");
            alert.setContentText("Вы удалили объект");
            option = alert.showAndWait();
        }
        else
        {
            alert = new Alert(Alert.AlertType.WARNING);
            alert.setTitle("RemoveBus");
            alert.setContentText("Не удалось удалить объект");
            option = alert.showAndWait();
        }
        showStorage();
    }

    @FXML
    private void ButtonShowStorage_Click(ActionEvent event)
    {
        FirstIncome();
        showStorage();
    }

    @FXML
    private void ButtonShowOnMap_Click(ActionEvent event) {
        FirstIncome();
        if (selected == null) {
            return;
        }
        gc.setFill(Color.WHITE);
        gc.fillRect(0, 0, canvasBus.getWidth(), canvasBus.getHeight());
        _mapsCollection.GetId(selected).ShowOnMap(gc);
    }

    @FXML
    private void ButtonMove_Click(ActionEvent event)
    {
        if (selected == null)
        {
            return;
        }

        String name = ((Button) event.getSource()).getId();
        Direction dir = Direction.None;
        switch (name) {
            case "buttonUp" -> dir = Direction.Up;
            case "buttonDown" -> dir = Direction.Down;
            case "buttonLeft" -> dir = Direction.Left;
            case "buttonRight" -> dir = Direction.Right;
        }
        _mapsCollection.GetId(selected).MoveObject(dir);
    }

    private void showStorage() {
        if (selected == null)
        {
            return;
        }
        gc.setFill(Color.WHITE);
        gc.fillRect(0, 0, pictureBoxBus.getWidth(), pictureBoxBus.getHeight());
        _mapsCollection.GetId(selected).ShowSet(gc);
    }

}


