package com.example.doubledeckerbus;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class DrawingDDB extends DrawingBus{
    Color _extraColor;
    boolean _ladder;
    boolean _secondStage;

    public DrawingDDB(int speed, float weight, Color bodyColor, int countOfDoors,
                      Color extraColor, boolean ladder, boolean secondStage) {
        super(speed, weight, bodyColor, countOfDoors);
        Bus = CreateDDB(speed, weight, bodyColor, countOfDoors, extraColor, ladder, secondStage);
    }

    private EntityDDB CreateDDB(int speed, float weight, Color bodyColor, int countOfDoors,
                      Color extraColor, boolean ladder, boolean secondStage) {
        _speed = speed;
        _weight = weight;
        _bodyColor = bodyColor;
        _countOfDoors = countOfDoors;
        _extraColor = extraColor;
        _ladder = ladder;
        _secondStage = secondStage;
        return new EntityDDB(speed, weight, bodyColor, extraColor, ladder, secondStage);
    }

    public DrawingDDB(int speed, float weight, Color bodyColor, Color extraColor, boolean ladder, boolean secondStage) {
        super(speed, weight, bodyColor);
        Bus = new EntityDDB(speed, weight, bodyColor, extraColor, ladder, secondStage);
    }

    public DrawingDDB(EntityBus bus, IDrawingDoors doors) {
        super(bus, doors);
    }

    @Override
    public void DrawTransport(GraphicsContext gc)
    {
        if (Bus == null) return;

        _startPosY += 30;
        super.DrawTransport(gc);
        _startPosY -= 30;
        EntityDDB ddb = (EntityDDB) Bus;

        gc.setFill(ddb.ExtraColor);
        if (ddb.SecondStage) {
            gc.fillRect(_startPosX, _startPosY + 10, 100, 30);
            gc.setFill(Color.BLACK);
            gc.fillRect(_startPosX + 30, _startPosY + 20, 10, 20);

            gc.setFill(Color.BLUE);
            gc.fillOval(_startPosX + 10, _startPosY + 15, 10, 15);
            gc.fillOval(_startPosX + 50, _startPosY + 15, 10, 15);
            gc.fillOval(_startPosX + 70, _startPosY + 15, 10, 15);
            gc.fillOval(_startPosX + 90, _startPosY + 15, 10, 15);
        }

        if (ddb.Ladder) {
            gc.strokeLine(_startPosX, _startPosY + 70, _startPosX, _startPosY + 10);
            gc.strokeLine(_startPosX + 10, _startPosY + 70, _startPosX + 10, _startPosY + 10);

            gc.strokeLine(_startPosX, _startPosY + 20, _startPosX + 10, _startPosY + 20);
            gc.strokeLine(_startPosX, _startPosY + 30, _startPosX + 10, _startPosY + 30);
            gc.strokeLine(_startPosX, _startPosY + 40, _startPosX + 10, _startPosY + 40);
            gc.strokeLine(_startPosX, _startPosY + 50, _startPosX + 10, _startPosY + 50);
            gc.strokeLine(_startPosX, _startPosY + 60, _startPosX + 10, _startPosY + 60);
        }
    }
}
