package com.example.doubledeckerbus;

import javafx.scene.canvas.GraphicsContext;

public class DrawingObjectBus implements IDrawingObject {
    private DrawingBus _bus = null;

    public DrawingObjectBus(DrawingBus bus)
    {
        _bus = bus;
    }

    public float Step() {
        if (_bus != null && _bus.Bus != null) {
            return _bus.Bus.Step;
        }
        return 0;
    }

    public Position GetCurrentPosition()
    {
        if (_bus != null) {
            return _bus.GetCurrentPosition();
        }
        return null;
    }

    public void MoveObject(Direction direction)
    {
        _bus.MoveTransport(direction);
    }

    public void SetObject(int x, int y, int width, int height)
    {
        _bus.SetPosition(x, y, width, height);
    }

    public void DrawingObject(GraphicsContext gc)
    {
        _bus.DrawTransport(gc);
    }

    public DrawingBus getBus() {
        return _bus;
    }
}
