package com.example.doubledeckerbus;

import java.util.Random;

public class DrawingPolymorphBus<T extends EntityBus, U extends IDrawingDoors> {
    Object[] buses;
    Object[] doors;

    int busesCount = 0;
    int doorsCount = 0;

    public DrawingPolymorphBus(int busesCount, int doorsCount) {
        buses = new Object[busesCount];
        doors = new Object[doorsCount];
    }

    public int AddEntity(T boat)
    {
        if(busesCount < buses.length){
            buses[busesCount] = boat;
            return busesCount++;
        }
        return -1;
    }

    public int AddDoors(U paddle)
    {
        if(doorsCount < doors.length){
            doors[doorsCount]=paddle;
            return doorsCount++;
        }
        return -1;
    }

    public DrawingBus CreateBus() {
        int idBus = new Random().nextInt(busesCount);
        int idDoor = new Random().nextInt(doorsCount);
        T selectedBus = (T)buses[idBus];
        U selectedDoors = (U)doors[idDoor];
        if (selectedBus instanceof EntityDDB) {
            return new DrawingDDB(selectedBus, selectedDoors);
        }
        return new DrawingBus(selectedBus, selectedDoors);
    }
}
