package com.example.doubledeckerbus;

import java.util.HashSet;
import java.util.Set;
import java.util.function.Consumer;

public class Event<T> {
    private final Set<Consumer<T>> listeners = new HashSet<>();

    public void AddListener(Consumer<T> listener) {
        listeners.add(listener);
    }

    public void Broadcast(T args) {
        listeners.forEach(x -> x.accept(args));
    }
}
