package com.example.doubledeckerbus;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import java.util.HashMap;
import java.util.List;

public class MapsCollection {
    HashMap<String, MapWithSetBusesGeneric<DrawingObjectBus, AbstractMap>> _mapStorages;

    public List<String> Keys() {
        return _mapStorages.keySet().stream().toList();
    }

    private int _pictureWidth;

    private int _pictureHeight;

    public MapsCollection(int pictureWidth, int pictureHeight)
    {
        _mapStorages = new HashMap<>();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    public void AddMap(String name, AbstractMap map)
    {
        if (Keys().contains(name)) return;
        _mapStorages.put(name, new MapWithSetBusesGeneric<DrawingObjectBus, AbstractMap>(_pictureWidth, _pictureHeight, map));
    }

    public void DelMap(String name)
    {
        _mapStorages.remove(name);
    }

    public MapWithSetBusesGeneric<DrawingObjectBus, AbstractMap> GetId(String id)
    {
        return _mapStorages.get(id);
    }

    public ObservableList<String> toObserveList() {
        ObservableList<String> result = FXCollections.observableArrayList();
        result.addAll(_mapStorages.keySet());
        return result;
    }

    public MapWithSetBusesGeneric<DrawingObjectBus, AbstractMap> get(String id) {
        if (_mapStorages.containsKey(id))
        {
            return _mapStorages.get(id);
        }
        return null;
    }

    public DrawingObjectBus get(String name, int id) {
        if (_mapStorages.containsKey(name))
        {
            return _mapStorages.get(name).getBus(id);
        }
        return null;
    }

}
