package com.example.doubledeckerbus;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Objects;


class SetBusesGeneric<T> {
    private ArrayList<T> _places;
    private int BusyPlaces = 0;

    private int _maxCount;

    public SetBusesGeneric(int count) {
        _maxCount = count;
        _places = new ArrayList<>();
    }

    public int Insert(T bus)
    {
        return Insert(bus, 0);
    }

    public int Insert(T bus, int position)
    {
        if (position < 0 || position >= _maxCount || BusyPlaces == _maxCount) return -1;

        BusyPlaces++;
        _places.add(position, bus);
        return position;
    }

    public T Remove(int position)
    {
        if (position < 0 || position >= _maxCount) return null;
        T savedBus = _places.get(position - 1);
        _places.set(position - 1, null);
        return savedBus;
    }

    public T Get(int position)
    {
        if (position < 0 || position >= _maxCount) return null;
        return _places.get(position);
    }


    public ArrayList<T> GetBuses() {
        ArrayList<T> result = new ArrayList<>();
        for (var bus: _places) {
            if (bus != null){
                result.add(bus);
            }
        }
        return result;
    }

    public int Count() {
        return _places.size();
    }
}


